import DataMessage from '../datamessage/DataMessage';
import Transcript from './Transcript';
import TranscriptionStatus from './TranscriptionStatus';
declare type TranscriptEvent = Transcript | TranscriptionStatus;
export declare class TranscriptEventConverter {
    /**
     * Decodes a list of TranscriptEvent from a data message.
     * @param dataMessage Data message to decode from
     * @returns List of TranscriptEvent
     * @throws {Error} If the data message payload cannot be decoded
     */
    static from(dataMessage: DataMessage): TranscriptEvent[];
}
export default TranscriptEvent;
